



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Java魔法堂：打包知识点之META-INF/MAINFEST.MF</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Java魔法堂：打包知识点之META-INF/MAINFEST.MF</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 11:20:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p><strong>一、前言　　　　　　　　　　　　　　　　　　　　　　　　　　&nbsp;　　　　　　　　&nbsp; <br /></strong></p>
<p>通过执行形如 jar -cvf src.jar src 命令将多个.class文件打包成JAR包时，你会发现JAR包中除了src目录外还多了个MATE-INF/MAINFEST.MF，那是为什么呢？</p>
<p>其实关于JAR包的描述信息、启动时的配置信息和安全性信息等均保存在META-INF下，因此了解META-INF目录对发布、部署十分重要的哦！下面仅为部分内容的整理，待日后深入实践后再补充完整。官方文档为：http://docs.oracle.com/javase/7/docs/technotes/guides/jar/jar.html</p>
<p><strong>二、META-INF/MAINFEST.MF清单文件组成元素　　　　　　　　　　　　　　　　</strong></p>
<p>META-INF/MAINFEST.MF清单文件由1个&nbsp;main-section&nbsp;和0到N个&nbsp;individual-section&nbsp;组成，而每个section中含有多个attribute组成，其中&nbsp;main-section&nbsp;中的attribute命名为&nbsp;main-attribute ,而&nbsp;individual-section&nbsp;中的attribute命名为&nbsp;perentry-attribute&nbsp;。</p>
<p>各个attribute间使用&lt;CR&gt;&lt;LF&gt;作为分隔符（Unix下则使用&lt;LF&gt;作为分隔符，Mac下则使用&lt;CR&gt;作为分隔符）。</p>
<p>individual-section&nbsp;以名为&nbsp;Name&nbsp;的&nbsp;perentry-attribute&nbsp;来标识该区域，且作为该区域的起始行。</p>
<p>示例：</p>
<div>
<pre class="prettyprint linenums">Manifest-Version: 1.0<br />
Created-By: 1.2 (Sun Microsystems Inc.)<br />
Sealed: true<br />
Name: foo/bar/<br />
Sealed: false</pre>
</div>
<p>main-section&nbsp;用于描述JAR包的安全、配置信息，和对JAR包内所有包和文件的默认信息。</p>
<p>每个&nbsp;individual-section&nbsp;用于描述JAR包中单个包或文件，但不是JAR包中的每个包和文件都必须配置&nbsp;individual-section&nbsp;，但对于需要被签名的文件就必须配置对应的&nbsp;individual-section&nbsp;了。</p>
<p><strong>三、&nbsp;main-attribute&nbsp;详解　　　　　　　　　　　　　　　　　　　　　　　　　　　　<br /></strong></p>
<p><strong>&nbsp; &nbsp;1. 常规属性</strong></p>
<div>
<pre class="prettyprint linenums">Mainfest-Version: JAR版本号<br />
Created-By: 生产者<br />
Signature-Version: 签名版本<br />
Class-Path: 依赖项列表，若存在多个依赖项时则采用空格分隔。依赖项路径为以JAR包路径为参考系的相对路径</pre>
</div>
<p><strong>&nbsp; &nbsp;2. 可执行的JAR包属性</strong></p>
<div>
<pre class="prettyprint linenums">Main-Class: main函数所在的全限定类名</pre>
</div>
<p><strong>四、&nbsp;perentry-attribute&nbsp;详解　　　　　　　　　　　　　　　　　　　　　　　　</strong></p>
<p><strong>&nbsp; 1.</strong> <strong>Name属性</strong>，&nbsp;individual-section&nbsp;的起始属性，包命名规范形如：com/test/myapp/，文件命名规范形如：com/test/myapp/MyApp.class。</p>
<p><strong>&nbsp; 2. 定义文件内容</strong></p>
<div>
<pre class="prettyprint linenums">Content-Type: MIME类型（格式为：type/subtype。例如，image/jpeg）</pre>
</div>
<p><strong>五、注意事项　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　&nbsp;</strong></p>
<p>1. 键值对独立占据一行或多行；</p>
<p>2. 每行最大长度为72个字符；</p>
<p>3. 每行的最后一个字符必须以回车符换行符结尾，而且回车符换行符不能有空格（使用正则表达式表达每行规范就是/^.+\S\r\n$/）；</p>
<p>4. 若键值对独立占据多行，那么从第二行起，必须以一个或以上的空格开头（使用正则表达式表达第二行及其余行的规范就是/^[ ]{1,}.+\S\r\n$/）。</p>
<p>尊重原创，转载请注明来自：<a href="http://www.cnblogs.com/fsjohnhuang/p/4046856.html" rel="external nofollow noreferrer">http://www.cnblogs.com/fsjohnhuang/p/4046856.html</a>&nbsp; ^_^肥仔John</p>
<p><strong>参考　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　　</strong></p>
<p>http://blog.csdn.net/zhifeiyu2008/article/details/8829637</p>
<p>http://docs.oracle.com/javase/7/docs/technotes/guides/jar/jar.html</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq44xd5q.html">jquery mobile系列问题汇总整理（传播知识，利己利人）</a>
		</li>
						<li><a href="https://www.batexi.com/a/rql4r669.html">Go语言实现HashSet</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkvzx9.html">Java中ArrayDeque，栈与队列</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjx3gz9.html">关于更新到Xcode8的一些问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wvpxoq.html">Node&period;js&amp;amp&semi;NPM的安装与配置&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4y1gojq.html">使用astyle格式化代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1krdx9.html">Apache让一台虚拟主机接受多域名解析&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1lwje9.html">Vagrant网络配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1g7zj9.html">ulimit -n修改单进程可打开最大文件数目</a>
		</li>
						<li><a href="https://www.batexi.com/a/8meeno6q.html">oracle分区表运行计划</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kj2e59.html">【Python系列】Python自动发邮件脚本-html邮件内容</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mpnwo8.html">WebLogic 安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zwnpg9.html">【开源】C&num;&period;NET股票历史数据采集，【附18年历史数据和源代码】</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge6goe8.html">vue2&period;X简单翻页&sol;分页</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj362y8.html">分布式数据中间件TDDL、Amoeba、Cobar、MyCAT架构比较</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1xv5yq.html">MyExceptionFilter 异常注入</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwmv0d8.html">NotBacon</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r53z4dq.html">标准C＋＋类std&colon;&colon;string的内存共享和Copy-On-Write&period;&period;&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q254wxlq.html">maven 打包zip，jsw相关</a>
		</li>
						<li><a href="https://www.batexi.com/a/902d52oq.html">Quartz学习&mdash;&mdash;SSMM&lpar;Spring&plus;SpringMVC&plus;Mybatis&plus;Mysql&rpar;和Quartz集成详解（转）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/wq134p58.html">C&num;--GDI&plus;的LinearGradientBrush类</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2430l8.html">&lbrack;算法导论&rsqb;二叉查找树的实现 &commat; Python</a>
			</li>
						<li><a href="https://www.batexi.com/a/390gy4m8.html">arcgis手动启动服务提示端口4000被使用</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq134d28.html">Linux下GCC和Makefile实例（从GCC的编译到Makefile的引入） 转</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m0ypp9.html">velocity 显示List和Map方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m0yx69.html">一次完整的HTTP事务分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/39rx6xm9.html">&lbrack;LeetCode&rsqb; Range Sum Query - Immutable &amp;amp&semi; Range Sum Query 2D - Immutable</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxv4n09.html">C&num;接口的使用场合，接口应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96ek2yq.html">JVM 参数翻译汉化解释</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9pryl4q.html">Reflector反编译&period;NET文件后修复【转】</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
